<template>
  <div>
    <v-card flat class="pa-10">
      <v-row justify="center">
        <v-col :cols="12" :sm="12" :md="6" :lg="6" :xl="6">
          <v-card class="mx-auto">
            <v-toolbar color="grey" dark>
              <v-spacer></v-spacer>
              <v-text-field
                v-model="searchUsuariosPerfil"
                label="Buscar"
                flat
                dark
                solo-inverted
                append-icon="mdi-magnify"
                hide-details
                clear-icon="mdi-close-circle-outline"
              ></v-text-field>
              <v-progress-linear
                :active="isLoadingUsuarios"
                :indeterminate="isLoadingUsuarios"
                absolute
                bottom
                color="primary"
              />
            </v-toolbar>
            <v-list
              height="300"
              max-height="300"
              style="overflow: auto;"
              two-line
              subheader
            >
              <v-subheader style="position : relative;">
                USUARIOS CON EL PERFIL
                <v-btn
                  style="top:10px;"
                  color="primary"
                  fab
                  dark
                  small
                  absolute
                  top
                  right
                  @click="getUsuariosPerfil"
                >
                  <v-icon color="white">mdi-sync</v-icon>
                </v-btn>
              </v-subheader>
              <v-list-item-group
                v-model="selectedUsuariosPerfil"
                color="primary"
              >
                <v-list-item
                  :value="item"
                  v-for="(item, indexItem) in searchedUsuariosPerfil"
                  :key="indexItem"
                >
                  <template v-slot:default="{}">
                    <v-list-item-avatar>
                      <v-icon large>mdi-account-circle-outline</v-icon>
                    </v-list-item-avatar>
                    <v-list-item-content>
                      <v-list-item-title>
                        <router-link
                          class="text-decoration-underline"
                          :to="toUsuario(item)"
                        >
                          {{ item.nombreUsuario }}
                        </router-link>
                      </v-list-item-title>
                      <v-list-item-subtitle
                        v-text="item.numeroEmpleado"
                      ></v-list-item-subtitle>
                    </v-list-item-content>
                    <v-list-item-action>
                      <v-tooltip bottom>
                        <template v-slot:activator="{ on, attrs }">
                          <v-btn
                            class="white--text"
                            color="grey"
                            v-bind="attrs"
                            v-on="on"
                            @click="deleteUsuarioPerfil(indexItem, item)"
                          >
                            <v-icon>mdi-account-arrow-right-outline</v-icon>
                          </v-btn>
                        </template>
                        <span
                          >Eliminar del perfil a {{ item.numeroEmpleado }}</span
                        >
                      </v-tooltip>
                    </v-list-item-action>
                  </template>
                </v-list-item>
              </v-list-item-group>
            </v-list>
          </v-card>
        </v-col>
        <v-col :cols="12" :sm="12" :md="6" :lg="6" :xl="6">
          <v-card class="mx-auto">
            <v-toolbar color="grey" dark>
              <v-spacer></v-spacer>
              <v-text-field
                v-model="searchUsuariosDisponibles"
                label="Buscar"
                flat
                dark
                solo-inverted
                append-icon="mdi-magnify"
                hide-details
                clear-icon="mdi-close-circle-outline"
              ></v-text-field>
              <v-progress-linear
                :active="isLoadingDisponibles"
                :indeterminate="isLoadingDisponibles"
                absolute
                bottom
                color="primary"
              />
            </v-toolbar>
            <v-list
              height="300"
              max-height="400"
              style="overflow: auto;"
              two-line
              subheader
            >
              <v-subheader style="position : relative;">
                USUARIOS DISPONIBLES SIN EL PERFIL
              </v-subheader>
              <v-list-item-group
                v-model="selectedUsuariosDisponibles"
                color="primary"
              >
                <v-list-item
                  :value="item"
                  v-for="(item, indexItem) in usuariosDisponibles"
                  :key="indexItem"
                >
                  <v-list-item-avatar>
                    <v-icon large>mdi-account-circle-outline</v-icon>
                  </v-list-item-avatar>
                  <v-list-item-content>
                    <v-list-item-title>
                      <router-link
                        class="text-decoration-underline"
                        :to="toUsuario(item)"
                      >
                        {{ item.nombreUsuario }}
                      </router-link>
                    </v-list-item-title>
                    <v-list-item-subtitle
                      v-text="item.numeroEmpleado"
                    ></v-list-item-subtitle>
                  </v-list-item-content>
                  <v-list-item-action>
                    <v-tooltip bottom>
                      <template v-slot:activator="{ on, attrs }">
                        <v-btn
                          class="white--text"
                          color="grey"
                          v-bind="attrs"
                          v-on="on"
                          @click="postUsuarioPerfil(indexItem, item)"
                        >
                          <v-icon>mdi-account-arrow-left-outline</v-icon>
                        </v-btn>
                      </template>
                      <span>Unir al perfil</span>
                    </v-tooltip>
                  </v-list-item-action>
                </v-list-item>
              </v-list-item-group>
            </v-list>
          </v-card>
        </v-col>
      </v-row>
    </v-card>
  </div>
</template>
<script>
import store from "@/store";
const axios = store.state.axiosApiLocal;
const serviceCommons = store.state.serviceCommons;
export default {
  name: "Component-Usuarios",
  props: ["perfilIn"],
  data() {
    return {
      isLoadingUsuarios: false,
      isLoadingDisponibles: false,
      searchUsuariosPerfil: null,
      searchUsuariosDisponibles: null,
      selectedUsuariosPerfil: null,
      selectedUsuariosDisponibles: null,
      usuariosPerfil: [],
      usuariosDisponibles: [],
      perfil: null,
    };
  },
  computed: {
    serviceCommons() {
      return serviceCommons;
    },
    searchedUsuariosPerfil() {
      let tempData = this.usuariosPerfil;
      if (this.searchUsuariosPerfil != "" && this.searchUsuariosPerfil) {
        tempData = tempData.filter((item) => {
          return JSON.stringify(item)
            .toUpperCase()
            .includes(this.searchUsuariosPerfil.toUpperCase());
        });
      }
      if (tempData.length > 0) {
        tempData = tempData.sort((a, b) => {
          let fa = a.nombreUsuario.toLowerCase();
          let fb = b.nombreUsuario.toLowerCase();
          if (fa < fb) {
            return -1;
          }
          if (fa > fb) {
            return 1;
          }
          return 0;
        });
      }
      return tempData;
    },
  },
  watch: {
    searchUsuariosDisponibles(val) {
      if (val && val != "" && val.length > 3) {
        this.getUsuariosDisponibles();
      } else {
        this.usuariosDisponibles = [];
      }
    },
  },
  methods: {
    toUsuario(usuario) {
      return {
        name: "modelo_negocio_accesos_usuarios_edicion",
        params: {
          usuario: this.serviceCommons.objectToBase64(usuario),
        },
      };
    },
    deleteUsuarioPerfil(indexItem, usuarioPerfil) {
      axios
        .delete(
          "/accesos/sistema/perfiles/v1/" +
            this.perfil.idPerfil +
            "/usuarios/" +
            usuarioPerfil.numeroEmpleado
        )
        .then((response) => {
          usuarioPerfil.idPerfilUsuario = null;
          this.usuariosPerfil.splice(indexItem, 1);
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        });
    },
    postUsuarioPerfil(indexItem, usuarioPerfil) {
      axios
        .post(
          "/accesos/sistema/perfiles/v1/" +
            this.perfil.idPerfil +
            "/usuarios/" +
            usuarioPerfil.numeroEmpleado
        )
        .then((response) => {
          let data = response.data;
          if (data) {
            usuarioPerfil.idPerfilUsuario = data.resultado.id;
            this.usuariosPerfil.push(usuarioPerfil);
            this.usuariosDisponibles.splice(indexItem, 1);
          }
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        });
    },
    getUsuariosPerfil() {
      this.isLoadingUsuarios = true;
      axios("/accesos/sistema/usuarios/v1/perfiles/" + this.perfil.idPerfil)
        .then((response) => {
          let data = response.data;
          if (data) {
            this.usuariosPerfil = data.resultado.usuarios;
          }
        })
        .catch((error) => {
          if (error.response && error.response.status == 404) {
            this.usuariosPerfil = [];
          } else {
            console.log(error);
          }
        })
        .finally(() => {
          this.isLoadingUsuarios = false;
        });
    },
    getUsuariosDisponibles() {
      this.isLoadingDisponibles = true;
      let body = {
        usuario: this.searchUsuariosDisponibles,
      };
      return axios
        .post(
          "/accesos/sistema/usuarios/v1/perfiles/" +
            this.perfil.idPerfil +
            "/busquedas/disponibles",
          body
        )
        .then((response) => {
          let data = response.data;
          if (data) {
            let usuarios = data.resultado.usuarios;
            if (usuarios.length > 0) {
              usuarios = usuarios.sort((a, b) => {
                let fa = a.nombreUsuario.toLowerCase();
                let fb = b.nombreUsuario.toLowerCase();
                if (fa < fb) {
                  return -1;
                }
                if (fa > fb) {
                  return 1;
                }
                return 0;
              });
            }
            this.usuariosDisponibles = usuarios;
          }
        })
        .catch((error) => {
          console.log(error);
          this.usuariosDisponibles = [];
        })
        .finally(() => {
          this.isLoadingDisponibles = false;
        });
    },
  },
  created() {
    this.perfil = this.perfilIn;
    this.getUsuariosPerfil();
  },
};
</script>
